% RL obvod - analyza vlastnosti (MATLAB 2020b), 3.3.2022
% prechodove a fekvencne charakteristiky, harmonicke napajanie
% Riesenie v MATLABe i v Simulinku

clc, clear all, clf, format compact
U=10; L=10e-3; R=10; % parametre obvodu
disp('Modelovanie serioveho RL obvodu')
T=L/R;      % casova konstanta RL obvodu
wz=1/T;     % kruhova frekvencia bodu zlomu ALFCH
Tsim=0.1;  % doba simulacie v Simulinku
Tstep=5*T;  % rozsah Step
wmin=1e2;wmax=1e4; % rozsah LFCH v MATLABe
w=1500;     % kruhova frekvencia sinus napatia
f=w/(2*pi); % frekvencia sinusovky (len pre informaciu)
Tsin=1/f;   % doba periody sinusovky
Tsim=2*Tsin;% doba simulacie v Simulinku pre sinus.napajanie
form1 = 'kruhova frekvencia bodu zlomu = %4.0f rad/s \n';
fprintf(form1,wz)

% Vypocet a zobrazenie prenosovych funkcii
numR=[1]; numL=[T 0]; % numI=numR/R; - prud netreba (je vo fáze s uR)
den=[T 1]; % menovatel je spolocny pre cely obvod
FR=tf(numR,den), FL=tf(numL,den), % FI=tf(numI,den);

figure(1) % zobrazenia prechodovych a LCH {uL,uR} v jednom grafe
subplot(2,2,1), step(FR,FL,Tstep), grid, legend('FR','FL') 
   title("RL obvod: F_R(s), F_L(s) pre R="+R+" \Omega, L ="+L+" H")
subplot(1,2,2), bode(FR,FL,{wmin,wmax}), grid, legend('F_R','F_L') 
   title('Bode: F_R(j\omega), F_L(j\omega)')
subplot(2,2,3), step(U*FR,U*FL,Tstep), grid, legend('uR','uL') 
   title("u_R(t), u_L(t)  pri U="+U+" V")
   xlabel ("\rightarrow  t [s]"), ylabel ("\rightarrow u(t) [V]")
% Pozn.: 1) pre úpravu grafu klikni 2x do grafu 
%        2) pre špec. znaky pozri v helpe: >> doc ylabel
%        3) do grafu možno vpísať informácie pomocoi text a gtext

figure(2) % riesenie v Simulinku, napajanie step, sinus, chirp, 
sim('RL_obvod_S')
% Pozn. blok ToWorkspace nastaviť: Save format = Array, Sample time = -1 
subplot(1,2,2), bode(FR,FL,{wmin,wmax}), grid, legend('F_R','F_L') 
subplot(1,2,1) % pri ~ napájaní je vhodné vytlačiť k napätiam aj LFCh
plot (ans.tout, ans.uR, ans.tout, ans.uL, 'LineWidth',1), grid 
   title("u_L(t), u_R(t) pre Usin, w ="+w+" rad/s"), legend('u_L','u_R') 
   xlabel ("\rightarrow  t [s]"), ylabel ("\rightarrow u(t) [V]") % popis osí
%  xlim([0 0.015]), ylim([-1 1]) % prípadná úprava mierok grafu
